#!/usr/bin/python
#

# pgst - PostgreSQL SQL Tool v. 1.3
# Copyright © 2004, Mike McKee

# A useful but simple editor for PostgreSQL databases.

# Was created in editable Python and Glade-2 files on RH9 Linux. My only resources were the Python and PyGTK
# html docs that came with RH9, some occasional review on groups.google.com, and the *.py files that RedHat
# uses for their control panels and other system tools. I am deeply indebted to RedHat for what crumbs they
# left behind for me so that I could learn this on my own.

# You may change and re-release as commercial and customized versions per the license. See artistic license.


# the imports below I just pulled from boilerplate from redhat control panels
# and then added others as I received errors
import sys;
import os;
import string;
import popen2;
import pygtk;
pygtk.require('2.0');
import gtk;
import gobject;
import gtk.gdk;
import gtk.glade;
from gtk import TRUE, FALSE;

# assign our globals
global txtSQLFont;
global txtResultFont;
global gsHomeDir;
global gbLookupDatabases;
global gsSQLTab1;
global gsResultTab1;
global gsSQLTab2;
global gsResultTab2;
global gsSQLTab3;
global gsResultTab3;
global gnNextTab;
global gbToldOnce;
global window;

# our signal handling (mostly in menu order)
def on_ConnectServer(*args):
	global gbLookupDatabases;
	global gbToldOnce;
	gbToldOnce = FALSE;
	gbLookupDatabases = FALSE;
	sHost = GetWidgetText('host');
	if (StrTrim(string.lower(sHost)) == 'localhost'):
		sPort = GetWidgetText('port');
		sCmd = 'psql -h "' + sHost + '" -p ' + sPort + ' -U postgres -l';
		sResult = RunBash(sCmd);
		if (StrContains(sResult, 'No pg_hba.conf entry') and (gbToldOnce == FALSE)):
			MessageBox("Note: For this to work locally, please edit pg_hba.conf and add the following line:\n\n" +
			"host  all  all  127.0.0.1  255.255.255.255  trust");
			gbToldOnce = TRUE;
	Widget('host').grab_focus();
	ShowWindow('connect_server');
	
def on_OpenSQL(*args):
	sFile = PrepareOpenFile('Select SQL');
	if (sFile != ''):
		sResult = ReadFile(sFile);
		SetWidgetText('txtSQL',sResult);
	
def on_SaveSQL(*args):
	sFile = PrepareSaveFile('Save SQL', 'sql', 1);
	RemoveFile(sFile);
	sResults = GetWidgetText('txtSQL');
	SaveFile(sFile, sResults);
			
def on_SaveResults(*args):
	sFile = PrepareSaveFile('Save Results', 'txt', 1);
	if (sFile == ''):
		return;
	RemoveFile(sFile);
	sResults = GetWidgetText('txtResult');
	SaveFile(sFile, sResults);
			
def on_SaveResultsPipeDelimited(*args):
	sFile = PrepareSaveFile('Save Results Delimited', 'txt', 1);
	if (sFile == ''):
		return;
	RemoveFile(sFile);
	sSQL = GetWidgetText('txtSQL');
	sResult = PgsqlDelimited(sSQL);
	SaveFile(sFile, sResult);
	
def on_SaveAllAsPDF(*args):
	sFile = PrepareSaveFile('Save As PDF', 'pdf', 1);
	if (sFile == ''):
		return;
	RemoveFile(sFile);
	sPDF = sFile;
	sSQL = GetWidgetText('txtSQL');
	sResult = GetWidgetText('txtResult');
	sOutput = "SQL:\n\n" + sSQL + "\n\nResults:\n\n" + sResult;
	sFile = "/tmp/pgst.txt";
	SaveFile(sFile, sOutput);
	sCmd = 'a2ps --center-title="' + sPDF + '" --landscape -f7 --columns=1 -o /tmp/pgst.ps /tmp/pgst.txt';
	RunBash(sCmd);
	sCmd = 'ps2pdf /tmp/pgst.ps "' + sPDF + '"';
	RunBash(sCmd);
	sCmd = 'xpdf "' + sPDF + '"';
	SpawnBash(sCmd);
	
def on_QuickPrint(*args):
	sSQL = GetWidgetText('txtSQL');
	sResult = GetWidgetText('txtResult');
	sOutput = "SQL:\n\n" + sSQL + "\n\nResults:\n\n" + sResult;
	sFile = "/tmp/pgst.txt";
	SaveFile(sFile, sOutput);
	sCmd = "lpr -r /tmp/pgst.txt";
	SpawnBash(sCmd);
			
def on_Print(*args):
	sSQL = GetWidgetText('txtSQL');
	sResult = GetWidgetText('txtResult');
	sOutput = "SQL:\n\n" + sSQL + "\n\nResults:\n\n" + sResult;
	sFile = "/tmp/pgst.txt";
	SaveFile(sFile, sOutput);
	sCmd = 'a2ps --center-title="Report" --landscape -f7 --columns=1 -o /tmp/pgst.ps /tmp/pgst.txt';
	RunBash(sCmd);
	sCmd = 'ggv /tmp/pgst.ps';
	SpawnBash(sCmd);
	
def on_Quit(*args):
	QuitAll();
	
def on_Edit(*args):
	if (Widget('txtSQL').is_focus()):
		b = Widget('txtSQL').get_buffer().get_selection_bounds();
		try:
			t1 = b[0];
			t2 = b[1];
			EnableWidget('cut1');
			EnableWidget('copy1');
			EnableWidget('clear1');
		except:
			DisableWidget('cut1');
			DisableWidget('copy1');
			DisableWidget('clear1');
	if (Widget('txtResult').is_focus()):
		b = Widget('txtResult').get_buffer().get_selection_bounds();
		try:
			t1 = b[0];
			t2 = b[1];
			EnableWidget('cut1');
			EnableWidget('copy1');
			EnableWidget('clear1');
		except:
			DisableWidget('cut1');
			DisableWidget('copy1');
			DisableWidget('clear1');
	pass;
	
def on_Cut(*args):
	if (Widget('txtSQL').is_focus()):
		Widget('txtSQL').emit('cut-clipboard');
		on_txtSQLChangedCheck();
		return;
	if (Widget('txtResult').is_focus()):
		Widget('txtResult').emit('cut-clipboard');
		return;
	
def on_Copy(*args):
	if (Widget('txtSQL').is_focus()):
		Widget('txtSQL').emit('copy-clipboard');
		on_txtSQLChangedCheck();
		return;
	if (Widget('txtResult').is_focus()):
		Widget('txtResult').emit('copy-clipboard');
		return;

def on_Paste(*args):
	if (Widget('txtSQL').is_focus()):
		Widget('txtSQL').emit('paste-clipboard');
		on_txtSQLChangedCheck();
		return;
	if (Widget('txtResult').is_focus()):
		Widget('txtResult').emit('paste-clipboard');
		return;

def on_Clear(*args):
	if (Widget('txtSQL').is_focus()):
		Widget('txtSQL').emit('delete-from-cursor', 0, 0);
		on_txtSQLChangedCheck();
		return;
	if (Widget('txtResult').is_focus()):
		Widget('txtResult').emit('delete-from-cursor', 0, 0);
		return;

def on_SelectAll(*args):
	if (Widget('txtSQL').is_focus()):
		o = Widget('txtSQL').get_buffer();
		o.move_mark_by_name('selection_bound',o.get_start_iter());
		o.move_mark_by_name('insert', o.get_end_iter());
		on_txtSQLChangedCheck();
		return;
	if (Widget('txtResult').is_focus()):
		o = Widget('txtResult').get_buffer();
		o.move_mark_by_name('selection_bound',o.get_start_iter());
		o.move_mark_by_name('insert', o.get_end_iter());
		return;
	
def on_ChangeSQLTab(*args):
	global gsSQLTab1;
	global gsResultTab1;
	global gsSQLTab2;
	global gsResultTab2;
	global gsSQLTab3;
	global gsResultTab3;
	global sPrevSQL4;
	global sPrevResults4;
	global gnNextTab;
	sHost = GetWidgetText('host');
	sDatabase = GetWidgetText('database');
	if (sDatabase == ''):
		sDatabase = 'template1';
	sTempSQL = gsSQLTab3;
	sTempResults = gsResultTab3;
	gsSQLTab3 = gsSQLTab2;
	gsResultTab3 = gsResultTab2;
	gsSQLTab2 = gsSQLTab1;
	gsResultTab2 = gsResultTab1;
	gsSQLTab1 = GetWidgetText('txtSQL');
	gsResultTab1 = GetWidgetText('txtResult');	
	SetWidgetText('txtSQL',sTempSQL);
	SetWidgetText('txtResult',sTempResults);
	gnNextTab += 1;
	if (gnNextTab == 5):
		gnNextTab = 1;
	Status('Host: ' + sHost + "\t\tDatabase: " + sDatabase + "\t\tTab: " + str(gnNextTab));
	
def on_ResetSQL(*args):
	SetWidgetText('txtSQL','');
	SetWidgetText('txtResult','');
	
def on_RunSQL(*args):
	if (Widget('txtSQL').is_focus()):
		b = Widget('txtSQL').get_buffer().get_selection_bounds();
		try:
			t1 = b[0];
			t2 = b[1];
			sSQL = Widget('txtSQL').get_buffer().get_slice(t1,t2,TRUE);
		except:	
			sSQL = GetWidgetText('txtSQL');
	StoreHistory(sSQL);
	sResult = Pgsql(sSQL);
	bError=FALSE;
	try:
		sResult = unicode(sResult, 'ascii');
	except:
		sResult = unicode(sResult,'iso-8859-1');
		bError=TRUE;
	if (Widget('mnuNoExtraLineWraps').get_active() == TRUE):
		sResult = sResult.replace('\r\n','\\r\\n') + "* NOTE: Has Extra Line Wraps Turned Off";
	SetWidgetText('txtResult',sResult);
	if (bError):
			ErrorBox("WARNING! One or more of your fields in your results contained a character outside something known as a UTF-8 character set. This very often occurs when non-English-speaking users post data to your database via a web page. These characters HAVE BEEN REPLACED BY SPACES in these results!\n\nIf you can locate the field in question, you can perhaps use the PostgreSQL function TO_ASCII(<FIELD>,'win1250') or TO_ASCII(<FIELD>,'latin1') to only return UTF-8 characters in your results, there by not losing data in your results.");
	
def on_StopTask(*args):
	sCmd = 'killall psql';
	RunBash(sCmd);
	
def on_SmallFonts(*args):
	if (Widget('mnuSmallFonts').get_active() == TRUE):
		# not desirable to me -- txtSQLFont = Widget('txtSQL').get_buffer().get_tag_table().lookup('txtSQLFont');
		txtResultFont = Widget('txtResult').get_buffer().get_tag_table().lookup('txtResultFont');
		# not desirable to me -- txtSQLFont.set_property('font', 'Misc Fixed 9');
		txtResultFont.set_property('font', 'Misc Fixed 9');		
	else:	
		# not desirable to me -- txtSQLFont = Widget('txtSQL').get_buffer().get_tag_table().lookup('txtSQLFont');
		txtResultFont = Widget('txtResult').get_buffer().get_tag_table().lookup('txtResultFont');
		# not desirable to me -- txtSQLFont.set_property('font', 'Courier 12, Luxi Mono 10,Bitstream Vera Sans Mono 8');
		txtResultFont.set_property('font', 'Courier 12, Luxi Mono 10,Bitstream Vera Sans Mono 8');
		
def on_FieldEditor(*args):
	global gbLookupTables;
	global gbLookupCols;
	global gbLookupVal;
	gbLookupTables = FALSE;
	gbLookupCols = FALSE;
	gbLookupVal = FALSE;
	SetWidgetText('fe_updatevalue','');
	SetWidgetText('fe_updatecolumn', '');
	SetWidgetText('fe_keyvalue','');
	SetWidgetText('fe_keycolumn', '');
	SetWidgetText('fe_table', '');
	Widget('fe_table').grab_focus();
	ShowWindow('field_editor');
	
def on_ListDatabases(*args):
	sCmd = 'select datname as databases from pg_database order by datname';
	sResult = Pgsql(sCmd);
	SetWidgetText('txtResult',sResult);
	
def on_ListUsers(*args):
	sCmd = 'select usename as users from pg_user';
	sResult = Pgsql(sCmd);
	SetWidgetText('txtResult',sResult);

def on_ListTables(*args):
	sCmd = "select tablename as tables, tableowner as owners from pg_tables where schemaname = 'public' order by tablename";
	sResult = Pgsql(sCmd);
	SetWidgetText('txtResult',sResult);

def on_ListDefs(*args):
	sHost = GetWidgetText('host');
	sPort = GetWidgetText('port');
	sUser = GetWidgetText('username');
	sDatabase = GetWidgetText('database');
	sDatabase = StrTrim(sDatabase);
	if (sDatabase == ''):
		sDatabase = 'template1';
	sCmd = 'pg_dump -h "' + sHost + '" -p ' + sPort + ' -U "' + sUser + '" -s -C "' + sDatabase + '" | grep -i "CREATE" -A 500000 | grep -v "\-\-" | grep -v "\\connect" | grep -v "SET " | tr -s "\n"';
	sResult = RunBash(sCmd);
	SetWidgetText('txtResult',sResult);
	
def on_EasySelect(*args):
	SetWidgetText('txtSQL',"SELECT * FROM table WHERE col = 'value';");		

def on_EasyInsert(*args):
	SetWidgetText('txtSQL',"INSERT INTO table (col1, col2) VALUES ('val1','val2');");		

def on_EasyUpdate(*args):
	SetWidgetText('txtSQL',"UPDATE table SET col = 'value' WHERE col = 'value';");		

def on_EasyDelete(*args):
	SetWidgetText('txtSQL',"DELETE FROM table WHERE col = 'value';");	
	
def on_EasyAddColumn(*args):
	SetWidgetText('txtSQL',"ALTER TABLE table ADD COLUMN newcol varchar(255);\nALTER TABLE table ALTER COLUMN newcol SET NOT NULL;");		

def on_BackupDatabase(*args):
	Widget('bak_host').grab_focus();
	ShowWindow('backup_database');
	
def on_RestoreDatabase(*args):
	Widget('rst_host').grab_focus();
	ShowWindow('restore_database');
	
def on_History(*args):
	nAfterMenuItem = 2;
	RemoveMenuItems('history1_menu', nAfterMenuItem);
	for i in range(10):
		sCmd = 'cat history.txt | tr -d "\n" | cut -d ";" -f ' + `(i+1)` + ' | tr -d "\n"';
		sResult = RunBash(sCmd);
		sResult = str(buffer(sResult, 0, 200));
		if (string.count(sResult, 'history.txt') > 0):
			return;
		if (sResult == ''):
			return;
		sLabel = string.replace(sResult, '_', '}~');
		sLabel = string.replace(sLabel, '}~', '__');
		AddMenuItem(
			'history1_menu', 
			sLabel, 
			sResult, 
			'pixmaps/history-16.png', 
			eval('on_h' + str(i+1))
		);
	
def on_ClearHistory(*args):
	RemoveFile('history.txt');
	
def on_h1(*args):
	sResult = args[0].get_name() + ';';
	SetWidgetText('txtSQL', sResult);
	
def on_h2(*args):
	sResult = args[0].get_name() + ';';
	SetWidgetText('txtSQL', sResult);
	
def on_h3(*args):
	sResult = args[0].get_name() + ';';
	SetWidgetText('txtSQL', sResult);
	
def on_h4(*args):
	sResult = args[0].get_name() + ';';
	SetWidgetText('txtSQL', sResult);
	
def on_h5(*args):
	sResult = args[0].get_name() + ';';
	SetWidgetText('txtSQL', sResult);
	
def on_h6(*args):
	sResult = args[0].get_name() + ';';
	SetWidgetText('txtSQL', sResult);
	
def on_h7(*args):
	sResult = args[0].get_name() + ';';
	SetWidgetText('txtSQL', sResult);
	
def on_h8(*args):
	sResult = args[0].get_name() + ';';
	SetWidgetText('txtSQL', sResult);
	
def on_h9(*args):
	sResult = args[0].get_name() + ';';
	SetWidgetText('txtSQL', sResult);
	
def on_h10(*args):
	sResult = args[0].get_name() + ';';
	SetWidgetText('txtSQL', sResult);
	
def on_Bookmarks(*args):
	nAfterMenuItem = 3;
	RemoveMenuItems('bookmarks1_menu', nAfterMenuItem);
	EnableWidget('deletebookmark1');
	for i in range(10):
		sCmd = 'cat bookmarks.txt | tr -d "\n" | cut -d ";" -f ' + `(i+1)` + ' | tr -d "\n"';
		sResult = RunBash(sCmd);
		sResult = str(buffer(sResult, 0, 200));
		if ((i == 0) and (sResult == '')):
			DisableWidget('deletebookmark1');
			return;			
		if (string.count(sResult, 'bookmarks.txt') > 0):
			return;
		if (sResult == ''):
			return;
		sLabel = string.replace(sResult, '_', '}~');
		sLabel = string.replace(sLabel, '}~', '__');			
		AddMenuItem(
			'bookmarks1_menu', 
			sLabel, 
			sResult, 
			'pixmaps/bookmark-16.png', 
			eval('on_b' + str(i+1))
		);
		
def on_AddBookmark(*args):
	sSQL = GetWidgetText('txtSQL');
	StoreBookmark(sSQL);
		
def on_DeleteBookmark(*args):
	i = 1;
	k = 0;
	for a in range(1,11):
		sRdoButtonName = 'rdo_b' + str(a);
		Widget(sRdoButtonName).set_property('label', '');
		Widget(sRdoButtonName).set_property('visible',FALSE);
	for m in Widget('bookmarks1_menu').get_children():
		if (i > 3):
			k += 1;
			sRdoButtonName = 'rdo_b' + str(k);
			sValue = m.get_property('name');
			sLabel = string.replace(sValue, '_', '}~');
			sLabel = string.replace(sLabel, '}~', '__');
			Widget(sRdoButtonName).set_property('label', sLabel);
			Widget(sRdoButtonName).set_property('visible', TRUE);
		i += 1;
	if (Widget('rdo_b1').get_property('visible') == FALSE):
		return;
	ShowWindow('delete_bookmark');
	
def on_b1(*args):
	sResult = args[0].get_name() + ';';
	SetWidgetText('txtSQL',sResult);
	
def on_b2(*args):
	sResult = args[0].get_name() + ';';
	SetWidgetText('txtSQL',sResult);
	
def on_b3(*args):
	sResult = args[0].get_name() + ';';
	SetWidgetText('txtSQL',sResult);
	
def on_b4(*args):
	sResult = args[0].get_name() + ';';
	SetWidgetText('txtSQL',sResult);
	
def on_b5(*args):
	sResult = args[0].get_name() + ';';
	SetWidgetText('txtSQL',sResult);
	
def on_b6(*args):
	sResult = args[0].get_name() + ';';
	SetWidgetText('txtSQL',sResult);
	
def on_b7(*args):
	sResult = args[0].get_name() + ';';
	SetWidgetText('txtSQL',sResult);
	
def on_b8(*args):
	sResult = args[0].get_name() + ';';
	SetWidgetText('txtSQL',sResult);
	
def on_b9(*args):
	sResult = args[0].get_name() + ';';
	SetWidgetText('txtSQL',sResult);
	
def on_b10(*args):
	sResult = args[0].get_name() + ';';
	SetWidgetText('txtSQL',sResult);
	
def on_QuickPostgreSQLHelp(*args):
	ShowWindow('sqlhelp');
	
def on_AllPostgreSQLCommands(*args):
	sFolderPath = TranslateApproxFolderPath('/usr/share/doc/postgre');
	sHelpFile = sFolderPath + '/html/reference.html';
	OpenMozilla('file', sHelpFile);
		
def on_PostgreSQLTutorial(*args):	
	sFolderPath = TranslateApproxFolderPath('/usr/share/doc/postgre');
	sHelpFile = sFolderPath + '/html/tutorial.html';
	OpenMozilla('file', sHelpFile);

def on_PostgreSQLConfiguration(*args):	
	ShowWindow('sqlconfig');
	
def on_ConfigureStoredProcedures(*args):	
	ShowWindow('procconfig');

def on_CompletePostgreSQLManual(*args):
	sFolderPath = TranslateApproxFolderPath('/usr/share/doc/postgre');
	sHelpFile = sFolderPath + '/html/index.html';
	OpenMozilla('file', sHelpFile);

def on_About(*args):
	ShowWindow('about');
	
# and now the ancillary signals

def on_DatabaseClicked(*args):
	global gbLookupDatabases;
	# If you think this function is confusing, believe me, I feel the same!
	# I had a dickens of a time trying to find out how to event trap the popdown listbox button!
	# Out of sheer luck and 3 hours of frustrating trial and error, I found something workable!
	if (args[0].is_focus()):
		try:
			a = args[1].device.name;
		except:
			try:
				a = args[1].button;
			except:
				try:
					a = args[1].keyval;
				except:
					try:
						if ((args[1].type == 12) and ((args[1].in_ == 0) or (args[1].in_ == 1)) and (gbLookupDatabases == FALSE)):
							gbLookupDatabases = TRUE;
							sHost = GetWidgetText('host');
							sPort = GetWidgetText('port');
							sCmd = 'psql -h "' + sHost + '" -p ' + sPort + ' -U postgres -l | grep -i "|" | grep -iv "\-+\-" | grep -iv "Encoding" | cut -d "|" -f 1 | tr -d " "';
							# sResult = "Database List Downloaded\n";
							sResult = RunBash(sCmd);
							sResult = sResult[:-1];
							if (StrDoesNotContain(sResult, 'psql:')):
								aDatabases = string.split(sResult, "\n");
								Widget('database').set_popdown_strings(aDatabases);
					except:
						pass;
	try:
		Widget('username').grab_focus(); # a recursion bug occurs that makes this popdown work right! go figure
	except:
		pass;
	return;

def on_TableClicked(*args):
	global gbLookupTables;
	global gbLookupCols;
	# If you think this function is confusing, believe me, I feel the same!
	# I had a dickens of a time trying to find out how to event trap the popdown listbox button!
	# Out of sheer luck and 3 hours of frustrating trial and error, I found something workable!
	if (args[0].is_focus()):
		try:
			a = args[1].device.name;
		except:
			try:
				a = args[1].button;
			except:
				try:
					a = args[1].keyval;
				except:
					try:
						if ((args[1].type == 12) and ((args[1].in_ == 0) or (args[1].in_ == 1)) and (gbLookupTables == FALSE)):
							gbLookupTables = TRUE;
							gbLookupCols = FALSE;
							sHost = GetWidgetText('host');
							sPort = GetWidgetText('port');
							sUser = GetWidgetText('username');
							sDatabase = GetWidgetText('database');
							sSQL = "select tablename as tables from pg_tables where schemaname = 'public' order by tablename";
							sCmd = 'psql -h "' + sHost + '" -p ' + sPort + ' -U "' + sUser + '" -d "' + sDatabase + '" -c "' + sSQL + '" | grep -iv "\-\-\-\-\-" | grep -iv "tables" | grep -iv " rows)" | tr -d " "'; 
							sResult = RunBash(sCmd);
							# sResult = "Table List Downloaded\n" + sResult;
							sResult = sResult[:-2];
							if (StrDoesNotContain(sResult, 'psql:')):
								aTables = string.split(sResult, "\n");
							Widget('fe_table').set_popdown_strings(aTables);
							pass;
					except:
						pass;
	gbLookupCols = FALSE;
	try:
		Widget('fe_updatevalue').grab_focus(); # a recursion bug occurs that makes this popdown work right! go figure
	except:
		pass;
	return;
	
def on_ColumnClicked(*args):
	global gbLookupCols;
	global gbLookupVal;
	# If you think this function is confusing, believe me, I feel the same!
	# I had a dickens of a time trying to find out how to event trap the popdown listbox button!
	# Out of sheer luck and 3 hours of frustrating trial and error, I found something workable!
	if (args[0].is_focus()):
		try:
			a = args[1].device.name;
		except:
			try:
				a = args[1].button;
			except:
				try:
					a = args[1].keyval;
				except:
					try:
						if ((args[1].type == 12) and ((args[1].in_ == 0) or (args[1].in_ == 1)) and (gbLookupCols == FALSE)):
							gbLookupCols = TRUE;
							gbLookupVal = FALSE;
							sHost = GetWidgetText('host');
							sPort = GetWidgetText('port');
							sUser = GetWidgetText('username');
							sDatabase = GetWidgetText('database');
							sTable = GetWidgetText('fe_table');
							sCmd = 'psql -h "' + sHost + '" -p ' + sPort + ' -U "' + sUser + '" -d "' + sDatabase + '" -c "\d \"' + sTable + '\"" | grep -i "|" | grep -iv " Modifiers" | cut -d "|" -f 1 | tr -d " " | sort'; 
							sResult = RunBash(sCmd);
							sResult = sResult[:-1];
							if (StrDoesNotContain(sResult, 'psql:')):
								aCols = string.split(sResult, "\n");
							Widget('fe_keycolumn').set_popdown_strings(aCols);
							Widget('fe_updatecolumn').set_popdown_strings(aCols);
					except:
						pass;
	try:
		Widget('fe_updatevalue').grab_focus(); # a recursion bug occurs that makes this popdown work right! go figure
	except:
		pass;
	return;
	
def on_ValueClicked(*args):
	global gbLookupVal;
	# If you think this function is confusing, believe me, I feel the same!
	# I had a dickens of a time trying to find out how to event trap the popdown listbox button!
	# Out of sheer luck and 3 hours of frustrating trial and error, I found something workable!
	if (args[0].is_focus()):
		try:
			a = args[1].device.name;
		except:
			try:
				a = args[1].button;
			except:
				try:
					a = args[1].keyval;
				except:
					try:
						if ((args[1].type == 12) and ((args[1].in_ == 0) or (args[1].in_ == 1)) and (gbLookupVal == FALSE)):
							gbLookupVal = TRUE;
							sHost = GetWidgetText('host');
							sPort = GetWidgetText('port');
							sUser = GetWidgetText('username');
							sDatabase = GetWidgetText('database');
							sTable = GetWidgetText('fe_table');
							Widget('fe_updatevalue').grab_focus();
							sKeyCol = GetWidgetText('fe_keycolumn');
							sCmd = 'psql -h "' + sHost + '" -p ' + sPort + ' -U "' + sUser + '" -d "' + sDatabase + '" -c "select \"' + sKeyCol + '\" from \"' + sTable + '\" order by \"' + sKeyCol + '\"" | grep -iv " rows)" | grep -iv "  username" | grep -iv "\-\-\-\-" | grep -iv "   " | sort';
							sResult = RunBash(sCmd);
							sResult = sResult.replace("\n ", "\n");
							sResult = sResult[1:];
							sResult = sResult[:-1];
							if (StrDoesNotContain(sResult, 'psql:')):
								aCols = string.split(sResult, "\n");
							Widget('fe_keyvalue').set_popdown_strings(aCols);
					except:
						pass;
	try:
		Widget('fe_updatevalue').grab_focus(); # a recursion bug occurs that makes this popdown work right! go figure
	except:
		pass;
	return;	

def on_SQLKeyPress(*args):
	if (args[1].keyval == 65293):
		if (Widget('mnuRunSQLOnEnterKey').get_active() == TRUE):
			sSQL = GetWidgetText('txtSQL');
			StoreHistory(sSQL);
			sResult = Pgsql(sSQL);
			SetWidgetText('txtResult',sResult);
			sSQL = string.replace(sSQL,"--","");
			sSQL = string.replace(sSQL,"\n","\n--");
			sSQL = sSQL[:-2];
			SetWidgetText('txtSQL', '--' + sSQL);
	if ((args[1].state == 20) and (args[1].keyval == 120)):
		on_Cut(args);
	if ((args[1].state == 20) and (args[1].keyval == 99)):
		on_Copy(args);
	pass;

def on_DeleteBookmarkNow(*args):
	for i in range(1,11):
		sRdoButtonName = 'rdo_b' + str(i);
		if (Widget(sRdoButtonName).get_active()):
			DeleteBookmark(i);
	HideWindow('delete_bookmark');
	
def on_DeleteBookmarkCancel(*args):
	HideWindow('delete_bookmark');		
	
def on_ConnectNow(*args):
	sHost = GetWidgetText('host');
	sDatabase = GetWidgetText('database');
	sPort = GetWidgetText('port');
	sUser = GetWidgetText('username');
	sCmd = 'psql -h "' + sHost + '" -p ' + sPort + ' -U "' + sUser + '" -d "' + sDatabase + '" -c "end"';
	sResult = RunBash(sCmd);
	if (StrContains(sResult, 'unknown host name')):
		ErrorBox('The database server ' + sHost + ' cannot be found.');
		return;		
	if (StrContains(sResult, 'could not connect to server')):
		ErrorBox('Either the PostgreSQL service is not started, not configured, or port ' + sPort + ' is not correct.');
		return;		
	if (StrContains(sResult, 'user')):
		ErrorBox('The username ' + sUser + ' is not correct.');
		return;	
	if (StrContains(sResult, 'Database "')):
		ErrorBox('The database ' + sDatabase + ' cannot be found.');
		return;		
	EnableWidget('mnuOpenSQL');
	EnableWidget('mnuSaveSQL');
	EnableWidget('mnuSaveResults');
	EnableWidget('mnuSaveResultsPipeDelimited');
	EnableWidget('mnuSaveAllAsPDF');
	EnableWidget('mnuQuickPrint');
	EnableWidget('mnuPrint');
	EnableWidget('mnuFieldEditor');
	Status('Host: ' + sHost + "\t\tDatabase: " + sDatabase + "\t\tTab: " + str(gnNextTab));
	HideWindow('connect_server');

def on_ConnectCancel(*args):
	HideWindow('connect_server');
	
def on_BackupNow(*args):
	sUser = GetWidgetText('bak_user');
	sDatabase = GetWidgetText('bak_database');
	sFile = GetWidgetText('bak_file');
	sCmd = 'vacuumdb -U "' + sUser + '" -z "' + sDatabase + '"';
	RunBash(sCmd);
	sCmd = 'pg_dump -U "' + sUser + '" -f "' + sFile + '" -b -C -Z9 -F c "' + sDatabase + '"';
	RunBash(sCmd);
	HideWindow('backup_database');
	
def on_BackupCancel(*args):
	HideWindow('backup_database');
	
def on_RestoreNow(*args):
	bData = Widget('rst_data').get_active();
	bSchemas = Widget('rst_schemas').get_active(); 
	bDrop = Widget('rst_drop').get_active();
	sHost = GetWidgetText('rst_host');
	sPort = GetWidgetText('rst_port');
	sDatabase = GetWidgetText('rst_database');
	sUser = GetWidgetText('rst_user');
	sFile = GetWidgetText('rst_file');
	sCmd = 'createdb -O "' + sUser + '" -U postgres "' + sDatabase + '"';
	RunBash(sCmd);
	sCmd = 'pg_restore -i';
	#note if not bData or bSchemas, then it's bBoth, and that's the default, so I don't need to change the regular command line
	if (bData):
		sCmd += ' -a';
	if (bSchemas):
		sCmd += ' -s';
	if (bDrop):
		sCmd += ' -c';
	sCmd += ' -U "' + sUser + '" -d "' + sDatabase + '" "' + sFile + '"';
	RunBash(sCmd);
	HideWindow('restore_database');
	
def on_RestoreCancel(*args):
	HideWindow('restore_database');
	
def on_FieldEditorClose(*args):
	HideWindow('field_editor');
	
def on_FieldEditorSelectField(*args):
	sTable = GetWidgetText('fe_table');
	sKeyCol = GetWidgetText('fe_keycolumn');
	sKeyVal = GetWidgetText('fe_keyvalue');
	sUpdateCol = GetWidgetText('fe_updatecolumn');
	sCmd = 'SELECT ' + sUpdateCol + ' FROM ' + sTable + ' WHERE ' + sKeyCol + " = '" + sKeyVal + "';";
	sResult = Pgsql(sCmd);
	if (StrContains(sResult, '---\n') and StrContains(sResult, '\n(1 row)')):
		sResult = sResult[(string.find(sResult, '---\n')+4):];
		sResult = sResult.replace('\n(1 row)','');
		sResult = StrTrim(sResult);
		SetWidgetText('fe_updatevalue',sResult);
	else:
		# print sResult;
		if (StrContains(sResult, '(0 rows)')):
			sResult = 'No match for that key value could be found.';
		elif (StrContains(sResult, 'does not exist')):
			sResult = 'One or more fields did not match an entity in the database. No data returned. Check spelling of table and field names.';
		elif ((StrTrim(sTable) == '') or (StrTrim(sKeyCol) == '') or (StrTrim(sKeyVal) == '') or (StrTrim(sUpdateCol) == '')):
			sResult = 'One or more fields was not filled in. No data returned.';
		elif (StrContains(sResult, 'not found')):
			sResult = 'One or more fields did not match an entity in the database. No data returned. Check spelling of table and field names.';
		elif (StrDoesNotContain(sResult, '(1 row)')):
			sResult = 'That key value returned more than one row and cannot be displayed.';
		MessageBox(sResult);

def on_FieldEditorUpdateField(*args):
	sTable = GetWidgetText('fe_table');
	sKeyCol = GetWidgetText('fe_keycolumn');
	sKeyVal = GetWidgetText('fe_keyvalue');
	sUpdateCol = GetWidgetText('fe_updatecolumn');
	sUpdateVal = GetWidgetText('fe_updatevalue');
	sTemp = sUpdateVal;
	sTemp = sTemp.replace("'", "''");
	sCmd = 'UPDATE ' + sTable + ' SET ' + sUpdateCol + " = '" + sTemp + "' WHERE " + sKeyCol + " = '" + sKeyVal + "';";
	sCmd = sCmd.replace('\"','\\"');
	sResult = Pgsql(sCmd);
	if (StrContains(sResult, 'UPDATE 1')):
		sResult = 'Field updated.';
	if (StrContains(sResult, '(0 rows)') or StrContains(sResult, 'UPDATE 0')):
		sResult = 'No match for that key value could be found.';
	if ((StrTrim(sTable) == '') or (StrTrim(sKeyCol) == '') or (StrTrim(sKeyVal) == '') or (StrTrim(sUpdateCol) == '')):
		sResult = 'One or more fields was not filled in. No data returned.';
	if (StrContains(sResult, 'does not exist')):
		sResult = 'One or more fields did not match an entity in the database. No data returned. Check spelling of table and field names.';
	if (StrContains(sResult, 'not found')):
		sResult = 'One or more fields did not match an entity in the database. No data returned. Check spelling of table and field names.';
	MessageBox(sResult);
	
def on_QuickPostgreSQLHelpClose(*args):
	HideWindow('sqlhelp');

def on_PostgreSQLConfigurationClose(*args):	
	HideWindow('sqlconfig');
	
def on_ConfigureStoredProceduresClose(*args):
	HideWindow('procconfig');
	
def on_AboutClose(*args):
	HideWindow('about');
	
def on_txtSQLChangedCheck(*args):
	sText = StrTrim(GetWidgetText('txtSQL'));
	if (sText != ''):
		EnableWidget('mnuRunSQL');
		EnableWidget('mnuStopTask');
		EnableWidget('btnRunSQL');
		EnableWidget('btnStop');
	else:
		DisableWidget('mnuRunSQL');
		DisableWidget('mnuStopTask');
		DisableWidget('btnRunSQL');
		DisableWidget('btnStop');
	pass;

# and now our functions to make life easier
	
def DoNothing():
	print('test');

def GetWidgetText(sName):
	sResult = '';
	if (sName == 'database'):
		return Widget(sName).entry.get_text();
	if (sName == 'fe_table'):
		return Widget(sName).entry.get_text();
	if (sName == 'fe_keycolumn'):
		return Widget(sName).entry.get_text();
	if (sName == 'fe_keyvalue'):
		return Widget(sName).entry.get_text();
	if (sName == 'fe_updatecolumn'):
		return Widget(sName).entry.get_text();
	try: # for ordinary text fields
		sResult = Widget(sName).get_text();
	except:
		try: # for scrolling textboxes
			c1 = Widget(sName).get_buffer().get_start_iter();
			c2 = Widget(sName).get_buffer().get_end_iter();
			sResult = Widget(sName).get_buffer().get_slice(c1,c2,TRUE);
		except:
			a = '';
	if (sResult == ''):
		try: # for scrolling textboxes
			c1 = Widget(sName).get_buffer().get_start_iter();
			c2 = Widget(sName).get_buffer().get_end_iter();
			sResult = Widget(sName).get_buffer().get_slice(c1,c2,TRUE);
		except:
			sResult = '';
	return sResult;
	
def SetWidgetText(sName, sText):
	if (sText == ''):
		try:
			aReset = string.split('\n', "\n");
			Widget(sName).set_popdown_strings(aReset);
		except:
			a = '';	
	try:
		Widget(sName).get_buffer().set_text(sText);
	except:
		try:
			Widget(sName).set_text(sText);
		except:
			return;
	if (sName == 'txtSQL'):
		on_txtSQLChangedCheck();			
		
def Widget(sName):
	return MyWindows.get_widget(sName);		
		
def ShowWindow(thewindow):
    Widget(thewindow).show();
    
def HideWindow(thewindow):
    Widget(thewindow).hide();

def Destroy(thewindow):
    Widget(thewindow).destroy();

def SetSQLFont(*args):
	o = args[0].get_buffer();
	c1 = o.get_start_iter();
	c2 = o.get_end_iter();
	o.apply_tag(txtSQLFont,c1,c2);
	pass;
	
def SetResultFont(*args):
	o = args[0].get_buffer();
	c1 = o.get_start_iter();
	c2 = o.get_end_iter();
	o.apply_tag(txtResultFont,c1,c2);
	pass;

def Status(sMsg):
	Widget('statusbar1').pop(0);
	Widget('statusbar1').push(0,sMsg);

def MessageBox(sMsg):
	global window;
	dialog = gtk.MessageDialog(
		window, 
		gtk.DIALOG_MODAL | gtk.DIALOG_DESTROY_WITH_PARENT, 
		gtk.MESSAGE_INFO, 
		gtk.BUTTONS_OK, 
		sMsg
	);
	dialog.run();
	dialog.destroy();

def ErrorBox(sMsg):
	global window;
	dialog = gtk.MessageDialog(
		window, 
		gtk.DIALOG_MODAL | gtk.DIALOG_DESTROY_WITH_PARENT, 
		gtk.MESSAGE_WARNING, 
		gtk.BUTTONS_OK, 
		sMsg
	);
	dialog.run();
	dialog.destroy();

def QuestionYesNoBox(sMsg):
	global window;
	dialog = gtk.MessageDialog(
		window, 
		gtk.DIALOG_MODAL | gtk.DIALOG_DESTROY_WITH_PARENT, 
		gtk.MESSAGE_QUESTION, 
		gtk.BUTTONS_YES_NO, 
		sMsg
	);
	response = dialog.run();
	dialog.destroy();
	return response;

def QuestionOKCancelBox(sMsg):
	global window;
	dialog = gtk.MessageDialog(
		window, 
		gtk.DIALOG_MODAL | gtk.DIALOG_DESTROY_WITH_PARENT, 
		gtk.MESSAGE_QUESTION, 
		gtk.BUTTONS_OK_CANCEL, 
		sMsg
	);
	response = dialog.run();
	dialog.destroy();
	return response;

def RunBash(sBash):
	output, err = popen2.popen4(sBash);
	sResult = output.read();
	output.close();
	return sResult;

def SpawnBash(sBash):
	if (sBash[-1] != '&'):
		sBash = sBash + ' &';
	output, err = popen2.popen4(sBash);
	output.close();
	return;
		
def Pgsql(sSQL):
	sHost = GetWidgetText('host');
	sPort = GetWidgetText('port');
	sDatabase = GetWidgetText('database');
	sUser = GetWidgetText('username');
	if (sDatabase == ''):
		sDatabase = 'template1';
	sCmd = 'psql -h "' + sHost + '" -p ' + sPort + ' -d "' + sDatabase + '" -U "' + sUser + '" -c "' + sSQL + '"';
	sResult = RunBash(sCmd);
	return sResult;
	
def PgsqlDelimited(sSQL):
	sHost = GetWidgetText('host');
	sPort = GetWidgetText('port');
	sDatabase = GetWidgetText('database');
	sUser = GetWidgetText('username');
	sCmd = 'psql -A -F "~" -h "' + sHost + '" -p ' + sPort + ' -d "' + sDatabase + '" -U "' + sUser + '" -c "' + sSQL + '" | grep -v "(* rows)" | tr "|" ":" | tr "~" "|" ';
	return RunBash(sCmd);
	
def PrepareOpenFile(sTitleMessage):
	sFile = '';
	fb = gtk.FileSelection(sTitleMessage);
	fb.set_position(gtk.WIN_POS_CENTER);
	fb.set_filename(gsHomeDir);
	fb.show_all();
	result = fb.run();
	fb.hide();
	if (result == gtk.RESPONSE_OK):
		sFile = fb.get_filename();
		sFile = StrTrim(sFile);
		if ((StrRight(sFile, 1) == '/') or (sFile == '') or (sFile == '/')):
			MessageBox('No filename entered. Nothing opened.');
			return;		
	return sFile;	
	
def PrepareSaveFile(sTitleMessage, sFileExtension, bRootHomeSafety):
	fb = gtk.FileSelection(sTitleMessage);
	fb.set_position(gtk.WIN_POS_CENTER);
	fb.set_filename(gsHomeDir);
	fb.show_all();
	result = fb.run();
	fb.hide();
	if (result == gtk.RESPONSE_OK):
		sFile = fb.get_filename();
		sFile = StrTrim(sFile);
		if ((StrRight(sFile, 1) == '/') or (sFile == '') or (sFile == '/')):
			MessageBox('No filename entered. Nothing saved.');
			return;
		sFileExtension = StrLCase(sFileExtension);			
		if (StrLeft(sFileExtension, 1) != '.'):
			sFileExtension = '.' + sFileExtension;
		if (StrLCase(StrRight(sFile, 4)) != sFileExtension):
			sFile = sFile + sFileExtension;
		if (bRootHomeSafety):
			if ((StrLeft(sFile, 6) != '/root/') and (StrLeft(sFile, 6) != '/home/')):
				MessageBox('For your safety, this program can only save to \n/root and /home subdirectories.');
				return;
		sCmd = 'file "' + sFile + '"';
		sResult = RunBash(sCmd);
		if (StrDoesNotContain(sResult, "can't stat")):
			result = QuestionYesNoBox("Do you wish to overwrite\n'" + sFile + "' ?");
			if (result != gtk.RESPONSE_YES):
				return;
		return sFile;

def StrTrim(sInput):
	return string.strip(sInput);
				
def StrLCase(sInput):
	return string.lower(sInput);
	
def StrUCase(sInput):
	return string.upper(sInput);
									
def StrLeft(sInput, nIndex):
	return sInput[:nIndex];
	
def StrRight(sInput, nIndex):
	return sInput[(nIndex * -1):];

def StrContains(sHaystack, sNeedle):
	if (string.find(sHaystack, sNeedle) != -1):
		return TRUE;
	else:
		return FALSE;
		
def StrDoesNotContain(sHaystack, sNeedle):
	if (string.find(sHaystack, sNeedle) == -1):
		return TRUE;
	else:
		return FALSE;		
			
def ReadFile(sFile):
	sCmd = 'cat "' + sFile + '"';
	sResult = RunBash(sCmd);
	return sResult;
	
def RemoveFile(sFile):
	if (sFile == ''):
		return;
	try:
		sCmd = 'rm -f "' + sFile + '"';
		RunBash(sCmd);
	except:
		return;
	
def SaveFile(sFile, sContents):
	if (sFile == ''):
		return;
	try:
		sCmd = 'echo -en "' + sContents + '" > "' + sFile + '"';
		RunBash(sCmd);
	except:
		return;
	
def TranslateApproxFolderPath(sFolderPath):
	if ((sFolderPath[-1] == '*') or (sFolderPath[-1] == '/')):
		sFolderPath = sFolderPath[:-1];
	sCmd = 'cd ' + sFolderPath + '*; pwd | tr -d "\n"';
	sResult = RunBash(sCmd);
	return sResult;

def GetHomeDir():
	sCmd = 'cd ~; pwd | tr -d "\n"';
	sResult = RunBash(sCmd);
	return sResult + '/';

def OpenMozilla(sProtocol, sURL):
	sCmd = 'mozilla ' + sProtocol + '://' + sURL;
	SpawnBash(sCmd);

def StoreHistory(sSQL):
	sSQL = StrTrim(sSQL);
	if ((sSQL == '') or (sSQL == ';')):
		return;
	sCmd = 'echo -en "' + sSQL + '" | tr "\n" " " | tr "  " " " | tr -d ";" >> history.txt; echo ";" >> history.txt';	
	sResult = RunBash(sCmd);	
	sCmd = 'tail -n 10 history.txt | grep -x -v " ;" > history.bak; mv -f history.bak history.txt';
	sResult = RunBash(sCmd);	

def StoreBookmark(sSQL):	
	sSQL = StrTrim(sSQL);
	if ((sSQL == '') or (sSQL == ';')):
		MessageBox("Nothing to bookmark.");
		return;
	sCmd = 'echo -en "' + sSQL + '" | tr "\n" " " | tr "  " " " | tr -d ";" >> bookmarks.txt; echo ";" >> bookmarks.txt';
	sResult = RunBash(sCmd);
	sCmd = 'head -n 10 bookmarks.txt | grep -x -v " ;" > bookmarks.bak; mv -f bookmarks.bak bookmarks.txt';
	sResult = RunBash(sCmd);	
	
def DisableWidget(sName):
	Widget(sName).set_property('sensitive',FALSE);	

def EnableWidget(sName):
	Widget(sName).set_property('sensitive',TRUE);
	
def GetUser():
	sCmd = 'whoami | tr -d "\n"';
	sResult = RunBash(sCmd);
	return sResult;
	
def RemoveMenuItems(sMenu, nAfterMenuItem):
	i = 1;
	for m in Widget(sMenu).get_children():
		if (i > nAfterMenuItem):
			Widget(sMenu).remove(m);
		i += 1;
		
def AddMenuItem(sMenu, sLabel, sName, sImage, oSignal):
	mnu = gtk.ImageMenuItem(sLabel);
	mnu.set_name(sName);
	mnu.connect('activate', oSignal);
	Widget(sMenu).add(mnu);	
	img = gtk.Image();
	img.set_from_file(sImage);
	mnu.set_image(img);	
	img.show();
	mnu.show();
	return mnu;

def AddSeparatorMenuItem(sMenu):
	mnu = gtk.SeparatorMenuItem();
	Widget(sMenu).add(mnu);
	mnu.show();	
		
def DeleteBookmark(nBookmark):
	if ((nBookmark >= 1) and (nBookmark <= 10)):
		sCmd = 'head -n ' + `(nBookmark-1)` + ' bookmarks.txt > bookmarks.bak; tail -n `expr \`cat bookmarks.txt | grep -c -i ""\` - ' + str(nBookmark) + '` bookmarks.txt >> bookmarks.bak; mv -f bookmarks.bak bookmarks.txt';
		sResult = RunBash(sCmd);
	
def gtk_main_quit(*args):
    gtk.main_quit();

def Refresh():
    while gtk.events_pending():
        gtk.mainiteration(FALSE);

def QuitAll():
    Destroy('main');
    Destroy('connect_server');
    gtk.main_quit();
	
PROGNAME = 'pgst';

# load our Glade2 file with the GUI
MyWindows = gtk.glade.XML('pgst.glade',None,domain=PROGNAME);

# g var initizialization
window = None;
gsSQLTab1 = '';
gsResultTab1 = '';
gsSQLTab2 = '';
gsResultTab2 = '';
gsSQLTab3 = '';
gsResultTab3 = '';
gnNextTab = 1;
gsHomeDir = GetHomeDir();

# change whole app's font
Widget('main').get_settings().set_string_property('gtk-font-name', 'sans normal 9','');

# change font on the two main text fields
o = Widget('txtSQL').get_buffer();
txtSQLFont = o.create_tag('txtSQLFont');
txtSQLFont.set_property('font', 'Courier 12, Luxi Mono 10,Bitstream Vera Sans Mono 8');
o = Widget('txtResult').get_buffer();
txtResultFont = o.create_tag('txtResultFont');
txtResultFont.set_property('font', 'Courier 12, Luxi Mono 10,Bitstream Vera Sans Mono 8');

# connect our signals to our glade file object
MyWindows.signal_autoconnect(locals());

# set the toolbar tooltips because of a bug in PyGTK
tt = gtk.Tooltips();
tt.set_tip(Widget('btnConnectServer'), 'Connect Server', None);
tt.set_tip(Widget('btnResetSQL'), 'Reset Screen', None);
tt.set_tip(Widget('btnRunSQL'), 'Run SQL', None);
tt.set_tip(Widget('btnStop'), 'Stop Task', None);
tt.set_tip(Widget('btnChangeSQLTab'),'Change SQL Tab', None);
tt.enable();

# assign our default statusbar
Status("Host: localhost\t\tDatabase: template1\t\tTab:" + str(gnNextTab));

# build the dynamic part of our help
sResult = Pgsql('\h SELECT');
sResult = sResult + "\n\n\n" + Pgsql('\h SELECT INTO');
SetWidgetText('txtSELECT', sResult);
sResult = Pgsql('\h INSERT');
SetWidgetText('txtINSERT', sResult);
sResult = Pgsql('\h UPDATE');
SetWidgetText('txtUPDATE', sResult);
sResult = Pgsql('\h DELETE');
SetWidgetText('txtDELETE', sResult);
sResult = Pgsql('\h *');
SetWidgetText('txtFULL', sResult);
sResult = RunBash('cat config_pgsql.txt');
SetWidgetText('txtSQLCONFIG', sResult);
sResult = RunBash('cat config_plpgsql.txt');
SetWidgetText('txtPROCCONFIG', sResult);

# set some default field values
SetWidgetText('rst_file', gsHomeDir + 'backup.db');
SetWidgetText('bak_file', gsHomeDir + 'backup.db');
SetWidgetText('username', GetUser());
SetWidgetText('rst_user', GetUser());
SetWidgetText('bak_user', GetUser());

# disable some menu items and toolbar buttons
DisableWidget('mnuOpenSQL');
DisableWidget('mnuSaveSQL');
DisableWidget('mnuSaveResults');
DisableWidget('mnuSaveResultsPipeDelimited');
DisableWidget('mnuSaveAllAsPDF');
DisableWidget('mnuQuickPrint');
DisableWidget('mnuPrint');
DisableWidget('mnuRunSQL');
DisableWidget('mnuStopTask');
DisableWidget('mnuFieldEditor');
DisableWidget('btnRunSQL');
DisableWidget('btnStop');
SetWidgetText('host', 'localhost');
SetWidgetText('database', 'template1');
Widget('mnuNoExtraLineWraps').set_active(TRUE);

# the second part of changing the whole app's font requires this
Widget('host').ensure_style();
Widget('database').ensure_style();
Widget('port').ensure_style();
Widget('username').ensure_style();
Widget('txtSQL').ensure_style();
Widget('txtResult').ensure_style();
Widget('rst_host').ensure_style();
Widget('rst_port').ensure_style();
Widget('rst_database').ensure_style();
Widget('rst_file').ensure_style();
Widget('bak_user').ensure_style();
Widget('bak_host').ensure_style();
Widget('bak_port').ensure_style();
Widget('bak_database').ensure_style();
Widget('bak_file').ensure_style();
Widget('bak_user').ensure_style();

# show our main window and go into main loop
ShowWindow('main');
Widget('txtSQL').grab_focus();
gtk.main();
